// (C) 2013 Bogdan Cristian Tataroiu

#include <cstdio>
#include <cassert>
#include <vector>
#include <queue>

using namespace std;

const int MAXN = 200000;
const int MAXM = 200000;

int N, M;
vector<int> con[MAXN];

inline int bfs(int S) {
    vector<int> dist(N, -1);
    queue<int> Q;
    Q.push(S);
    dist[S] = 0;
    int MAX = 0;
    for (; !Q.empty(); Q.pop()) {
        int nod = Q.front();
        if (dist[nod] > MAX) {
            MAX = dist[nod];
        }
        vector<int> :: iterator it;
        for (it = con[nod].begin(); it != con[nod].end(); it++) {
            if (dist[*it] != -1) {
                continue;
            }

            dist[*it] = dist[nod] + 1;
            Q.push(*it);
        }
    }
    return MAX;
}

int main() {
    assert(freopen("amici.in", "rt", stdin));
    assert(freopen("amici.out", "wt", stdout));

    int T;
    assert(scanf("%d", &T) == 1);
    for (; T; T--) {
        assert(scanf("%d %d", &N, &M) == 2);
        assert(1 <= N && N <= MAXN);
        assert(1 <= M && M <= MAXM);
        for (int i = 0; i < N; i++) {
            con[i].clear();
        }
        for (int i = 0; i < M; i++) {
            int x, y;
            assert(scanf("%d %d", &x, &y) == 2);
            assert(1 <= x && x <= N);
            assert(1 <= y && y <= N);
            assert(x != y);
            x -= 1; y -= 1;
            con[x].push_back(y);
            con[y].push_back(x);
        }

        int len = bfs(N - 1);
        int cnt = 0;
        for (; (1 << cnt) < len; cnt++);

        printf("%d\n", cnt);
    }
    return 0;
}
