#include <cstdio>
#include <queue>
#include <vector>
#include <cassert>

using namespace std;

const int maxn = 200 * 1000 + 5;
const int INF = 2 * 1000 * 1000;

int n, m, i, j, a, b, diametru, d[maxn], t, ans;
vector<int> G[maxn];
queue <int> Q;

void BFS(int sursa) {
    
    Q.push(sursa);
    
    for(int i = 1; i <= n; ++i)
        d[i] = INF;    

    d[sursa] = 0;

    for(;!Q.empty();) {
        int act = Q.front();
        Q.pop();

        for(int i = 0; i < G[act].size(); ++i) {
            int vecin = G[act][i];
            if(d[vecin] == INF) {
                d[vecin] = d[act] + 1;
                Q.push(vecin);
            }
        }
    }
}

int main() {
    
    freopen("amici.in","r",stdin);
    freopen("amici.out","w",stdout);
    
    scanf("%d",&t);

    for(;t--;) {
    scanf("%d %d",&n,&m);
    
    assert(n >= 1 && n <= 21 * 1000);
    assert(m >= 1 && m <= 41 * 1000);
    for(i = 1; i <= n; ++i)
        G[i].clear();

    for(i = 1; i <= m; ++i) {
        scanf("%d %d",&a,&b);
        assert(a != b);
        G[a].push_back(b);
        G[b].push_back(a);
    }
    
    diametru = 0;

    for(i = 1; i <= n; ++i) {
        BFS(i);
        for(j = 1; j <= n; ++j)
            diametru = max(diametru, d[j]);
    }
        for(ans = 0; (1 << ans) < diametru; ans++);
        //fprintf(stderr,"%d\n",diametru);
        printf("%d\n", ans);
    }
    return 0;
}
