// (C) 2013 Bogdan Cristian Tataroiu

#include <cstdio>
#include <cassert>

using namespace std;

const int MAXN = 2048;

int N, M;
int m[MAXN][MAXN];
char ok[MAXN][MAXN];
int px[MAXN * MAXN], py[MAXN * MAXN];
char tmp[65536];

int main() {
    assert(freopen("bemo.in", "rt", stdin));
    assert(freopen("bemo.out", "wt", stdout));

    assert(scanf("%d %d ", &N, &M) == 2);
    for (int i = 0; i < N; i++) {
        fgets(tmp, 65536, stdin);
        char *p = tmp;
        for (int j = 0; j < M; j++) {
            int val = 0;
            for (; '0' <= *p && *p <= '9'; p++) {
                val = val * 10 + *p - '0';
            }
            for (; '0' > *p || *p > '9'; p++);
            assert(1 <= val && val <= N * M);
            m[i][j] = val - 1;

            px[m[i][j]] = i;
            py[m[i][j]] = j;
            ok[i][j] = 1;
        }
    }

    for (int i = 0; i < N * M; i++) {
        if (!ok[px[i]][py[i]]) {
            continue;
        }

        for (int j = px[i] - 1; j >= 0; j--) {
            if (py[i] + 1 < M && !ok[j][py[i] + 1]) {
                break;
            }
            for (int k = py[i] + 1; k < M; k++) {
                if (!ok[j][k]) {
                    break;
                }

                ok[j][k] = 0;
            }
        }

        for (int j = px[i] + 1; j < N; j++) {
            if (py[i] - 1 >= 0 && !ok[j][py[i] - 1]) {
                break;
            }
            for (int k = py[i] - 1; k >= 0; k--) {
                if (!ok[j][k]) {
                    break;
                }

                ok[j][k] = 0;
            }
        }
    }

    for (int i = 0; i < N; i++) {
        for (int j = 0; j < M; j++) {
            if (ok[i][j]) {
                printf("%d ", m[i][j] + 1);
            }
        }
    }
    printf("\n");

    return 0;
}
