#include<cstdio>
#include<cstring>
#include<vector>
#include<algorithm>
#include<set>
using namespace std;

#define NMAX 250010

int N, Q;
int value[NMAX];       
int used[NMAX];
int father[NMAX];

int num_paths;
int heavy[NMAX];
int depth[NMAX];
int how_many[NMAX];

int where[NMAX];
int position[NMAX];
int first_node[NMAX];
int prev[NMAX];
int is_free[NMAX];

set< pair<int, int> > Set[NMAX];

vector<int> tree[NMAX];

void dfs(int node, int d) {
	
	used[node] = 1; heavy[node] = 1; depth[node] = d;
	for(vector<int>::iterator it = tree[node].begin(); it != tree[node].end(); it++)
		if(!used[*it]) {
			dfs(*it, d + 1);
			heavy[node]+= heavy[*it];
			father[*it] = node;
		}
}

void heavy_path(int node, int path) {
	
	used[node] = 1;
	where[node] = path;
	position[node] = ++how_many[path];

	if(position[node] == 1) 
		first_node[path] = node;

	for(vector<int>::iterator it = tree[node].begin(); it != tree[node].end(); it++)
		if(!used[*it]) {
			if(is_free[node] == 0) {
				is_free[node] = 1;
				heavy_path(*it, path);
			}
			else {
				++num_paths;
                prev[num_paths] = node;         
				heavy_path(*it, num_paths);
			}
		}
}

void update(int node) {
	value[node] = (!value[node]);
	if(value[node]) 
		Set[ where[node] ].insert( make_pair(depth[node], node) );
	else {
		set< pair<int, int> >::iterator it = Set[ where[node] ].find( make_pair( depth[node], node ) );
		Set[ where[node] ].erase(it);
	}
}

int query(int x, int y) {
	
	int current_path = where[y];
//	printf ("!!%d\n", current_path);

	int result = -1;
	if (current_path != where[x])
		result = query (x, prev[current_path]);
	
	if (result != -1)
		return result;

	set < pair <int, int> >::iterator it, it2;
	if (current_path == where[x]) {
		it = Set[current_path].lower_bound( make_pair( depth[x], x ) );
		if (it == Set[current_path].end())
			return -1;

		int node = it->second;

		if( depth[node] > depth[y] )
			return -1;
		
		return node;		
	}
	
	 it = Set[current_path].begin();
	 if (it == Set[current_path].end())
		 return -1;
	 if (depth[it->second] > depth[y])
		 return -1;

	 return it->second;
}		

bool cmp(int x, int y) {
	return heavy[x] > heavy[y];
}

void read_tree() {
	
	int x, y;

	scanf("%d %d", &N, &Q);
	for(int i = 1; i < N; i++){
		scanf("%d %d", &x, &y);
		tree[x].push_back(y);
		tree[y].push_back(x);
	}
         
	dfs(1, 1);
    for(int i = 1; i <= N; i++)
		sort(tree[i].begin(), tree[i].end(), cmp);

	memset(used, 0, sizeof(used));

	num_paths = 1;
	heavy_path(1, 1);
//	printf("paths : %d\n", num_paths);
}

int main() {

	freopen("confuzie.in", "r", stdin);
	freopen("confuzie.out", "w", stdout);

	read_tree();

	int type, x, y;
	for(; Q; Q--) {
		scanf("%d", &type);
		if (type == 0) {
			scanf("%d", &x);
			update(x);
		}
		else {
			scanf("%d %d", &x, &y);
//			printf("%d %d : ", x, y);
			printf("%d\n", query(x, y));
//			printf("END\n");
		}
	}

	return 0;
}
