/* Andrei Parvu
   O(logN) / query, smen heavy path
*/

#include <cstdio>
#include <vector>
#include <set>
#include <assert.h>

using namespace std;

#define FLIP 0
#define QUERY 1

#define ii pair<int, int>
#define NMAX 250000
#define MMAX 450001

const int lg = 250005;

bool fst[lg];
int inaltime[lg], whichPath[lg], father[lg], D[lg], Max[lg];
int nr_paths;
vector<int> v[lg];
set<ii> sets[lg];
ii minElements[lg];
int ind, timp[lg][2];

void df(int nod, int adn) {
  fst[nod] = true;
  inaltime[nod] = adn;

  ind++;
  timp[nod][0] = ind;

  for (int i = 0; i < (int)v[nod].size(); i++) {
    if (!fst[v[nod][i]]) {
      df(v[nod][i], adn + 1);
      D[nod] += D[v[nod][i]];

      if (D[v[nod][i]] > D[Max[nod]]) {
        Max[nod] = v[nod][i];
      }
    }
  }

  D[nod]++;

  timp[nod][1] = ind;
}

void setPaths(int nod, int path) {
  fst[nod] = false;

  whichPath[nod] = path;

  if (Max[nod] != 0) {
    setPaths(Max[nod], path);
  }

  for (int i = 0; i < (int)v[nod].size(); i++) {
    if (fst[v[nod][i]] == true && v[nod][i] != Max[nod]) {
      nr_paths++;

      father[nr_paths] = nod;

      setPaths(v[nod][i], nr_paths);
    }
  }
}

void update(int nod) {
  int h = inaltime[nod], path = whichPath[nod];

  if (sets[path].find(make_pair(h, nod)) != sets[path].end()) {
    sets[path].erase(make_pair(h, nod));
  } else {
    sets[path].insert(make_pair(h, nod));
  }

  if (!sets[path].empty()) {
    minElements[path] = *sets[path].begin();
  } else {
    minElements[path] = make_pair(-1, 0);
  }
}

int query(int x, int y) {
  int startPath = whichPath[y], endPath = whichPath[x], rsp = -1;

  for (; startPath != endPath; ) {
    ii cur = minElements[startPath];

    if (cur.first != -1 && cur.first <= inaltime[y]) {
      rsp = cur.second;
    }

    y = father[startPath];
    startPath = whichPath[y];
  }

  set<ii> :: iterator it = sets[endPath].lower_bound(make_pair(inaltime[x],
        x));

  if (it != sets[endPath].end()) {
    if (it->first <= inaltime[y]) {
      rsp = it->second;
    }
  }

  return rsp;
}

int main() {
  freopen("confuzie.in", "rt", stdin);
  freopen("confuzie.out", "wt", stdout);

  int n, m, x, y;

  assert(scanf("%d%d", &n, &m) == 2);

  assert(1 <= n && n <= NMAX);
  assert(1 <= m && m <= MMAX);

  for (int i = 1; i < n; i++) {
    assert(scanf("%d%d", &x, &y) == 2);
    assert(1 <= x && x <= n);
    assert(1 <= y && y <= n);

    v[x].push_back(y);
    v[y].push_back(x);
  }

  nr_paths = 1;

  df(1, 1);

  setPaths(1, 1);

  for (int i = 1; i <= nr_paths; i++) {
    minElements[i] = make_pair(-1, 0);
  }

  for (int i = 0; i < m; i++) {
    int tip, nod;

    assert(scanf("%d", &tip) == 1);
    assert(tip == FLIP || tip == QUERY);

    if (tip == FLIP) {
      assert(scanf("%d", &nod) == 1);
      assert(1 <= nod && nod <= n);

      update(nod);
    } else {
      assert(scanf("%d%d", &x, &y) == 2);

      assert(1 <= x && x <= n);
      assert(1 <= y && y <= n);

      assert(timp[x][0] <= timp[y][0] && timp[y][1] <= timp[x][1]);


      printf("%d\n", query(x, y));
    }
  }

  return 0;
}

