// (C) 2013 Bogdan Cristian Tataroiu

#include <cstdio>
#include <cassert>
#include <vector>
#include <set>

using namespace std;

const int MAXN = 200000;
const int MAXM = 450001;

int N, M;

vector<int> con[MAXN];
int cnt[MAXN], child[MAXN], lvl[MAXN], p[MAXN];
int path[MAXN], flipped[MAXN];

int Pid = -1;
vector<vector<int> > paths;
vector<set<pair<int, int> > > sets;

void dfs(int k) {
    vector<int> :: iterator it;
    cnt[k] = 1; child[k] = -1;
    for (it = con[k].begin(); it != con[k].end(); it++) {
        if (*it == p[k]) {
            continue;
        }
        lvl[*it] = lvl[k] + 1;
        p[*it] = k;
        dfs(*it);
        cnt[k] += cnt[*it];
        if (child[k] == -1 || cnt[*it] > cnt[child[k]]) {
            child[k] = *it;
        }
    }

    if (child[k] == -1) {
        Pid += 1;
        path[k] = Pid;
        paths.push_back(vector<int>(1, k));
        sets.push_back(set<pair<int, int> >());
    } else {
        path[k] = path[child[k]];
        paths[path[k]].push_back(k);
    }
}

int main() {
    assert(freopen("confuzie.in", "rt", stdin));
    assert(freopen("confuzie.out", "wt", stdout));

    assert(scanf("%d %d", &N, &M) == 2);
    for (int i = 1; i < N; i++) {
        int x, y;
        assert(scanf("%d %d", &x, &y) == 2);
        assert(1 <= x && x <= N);
        assert(1 <= y && y <= N);
        assert(x != y);
        x -= 1; y -= 1;
        con[x].push_back(y);
        con[y].push_back(x);
    }
    p[0] = -1;
    dfs(0);

    for (int i = 0; i < M; i++) {
        int type;
        assert(scanf("%d", &type) == 1);
        assert(type == 0 || type == 1);
        if (type == 0) {
            int nod;
            assert(scanf("%d", &nod) == 1);
            assert(1 <= nod && nod <= N);
            nod -= 1;
            if (flipped[nod]) {
                flipped[nod] = 0;
                sets[path[nod]].erase(make_pair(lvl[nod], nod));
            } else {
                flipped[nod] = 1;
                sets[path[nod]].insert(make_pair(lvl[nod], nod));
            }
        } else if (type == 1) {
            int x, y;
            assert(scanf("%d %d", &x, &y) == 2);
            assert(1 <= x && x <= N);
            assert(1 <= y && y <= N);
            x -= 1; y -= 1;
            assert(lvl[x] <= lvl[y]);
            int rez = -2;
            for (; path[y] != path[x]; y = p[paths[path[y]].back()]) {
                if (!sets[path[y]].empty() &&
                    lvl[sets[path[y]].begin()->second] <= lvl[y]) {
                    rez = sets[path[y]].begin()->second;
                }
            }
            assert(path[y] == path[x]);
            set<pair<int, int> > :: iterator it;
            it = sets[path[y]].upper_bound(make_pair(lvl[x] - 1, 0x3f3f3f3f));
            if (it != sets[path[y]].end() && lvl[it->second] <= lvl[y]) {
                rez = it->second;
            }

            printf("%d\n", rez + 1);
        }
    }

    return 0;
}
