#include <cstdio>
#include <vector>
#include <set>

using namespace std;

#define FLIP 0
#define QUERY 1

#define ii pair<int, int>

const int lg = 250005;

bool fst[lg];
int inaltime[lg], timp[lg][2];
vector<int> v[lg];
set<ii> bigSet;
int ind;

void df(int nod, int adn) {
  fst[nod] = true;
  inaltime[nod] = adn;

  ind++;
  timp[nod][0] = ind;

  for (int i = 0; i < (int)v[nod].size(); i++) {
    if (!fst[v[nod][i]]) {
      df(v[nod][i], adn + 1);
    }
  }

  timp[nod][1] = ind;
}


void update(int nod) {
  int h = inaltime[nod];

  if (bigSet.find(make_pair(h, nod)) != bigSet.end()) {
    bigSet.erase(make_pair(h, nod));
  } else {
    bigSet.insert(make_pair(h, nod));
  }
}

int query(int x, int y) {
  set<ii> :: iterator start = bigSet.lower_bound(make_pair(inaltime[x], x)),
    end = bigSet.upper_bound(make_pair(inaltime[y], y)), it;

  for (it = start; it != end; it++) {
    int nodCur = it->second;

    if (timp[x][0] <= timp[nodCur][0] && timp[nodCur][1] <= timp[x][1] &&
        timp[nodCur][0] <= timp[y][0] && timp[y][1] <= timp[nodCur][1]) {
      return nodCur;
    }
  }

  return -1;
}

int main() {
  freopen("confuzie.in", "rt", stdin);
  freopen("confuzie.out", "wt", stdout);

  int n, m, x, y;

  scanf("%d%d", &n, &m);
  for (int i = 1; i < n; i++) {
    scanf("%d%d", &x, &y);
    v[x].push_back(y);
    v[y].push_back(x);
  }

  df(1, 1);

  for (int i = 0; i < m; i++) {
    int tip, nod;

    scanf("%d", &tip);

    if (tip == FLIP) {
      scanf("%d", &nod);

      update(nod);
    } else {
      scanf("%d%d", &x, &y);

      printf("%d\n", query(x, y));
    }
  }

  return 0;
}

