#include <stdio.h>
#include <string.h>
#include <time.h>
#include <vector>

using namespace std;

#define NMAX 200111
#define DEBUG 0
#define FILEIN "confuzie.in"
#define FILEOUT "confuzie.out"

vector<int> vec[NMAX];
int N, M;

void ReadInput() {
	int i, j, k;

	freopen(FILEIN, "r", stdin);
	scanf("%d %d", &N, &M);
	
	for (k = 1; k < N; k++) {
		scanf("%d %d", &i, &j);
		vec[i].push_back(j);
		vec[j].push_back(i);
	}
}

char visited[NMAX];
int stk[NMAX], stkidx[NMAX], parent[NMAX], idxmin[NMAX], idxmax[NMAX], q[NMAX], level[NMAX], idx, niv;
vector<int> sons[NMAX];

void DFS() {
	int i, j;

	memset(visited, 0, sizeof(visited));
	visited[1] = 1;
	parent[1] = 1;

	stk[niv = 1] = 1;
	stkidx[1] = -1;
	idx = 1;
	idxmin[1] = 1;
	level[1] = 1;
	q[1] = 1;
	
	while (niv >= 1) {
		stkidx[niv]++;
		i = stk[niv];

		if (stkidx[niv] >= vec[i].size()) {
			idxmax[i] = idx;
			niv--;
		} else {
			j = vec[i][stkidx[niv]];
			if (!visited[j]) {
				visited[j] = 1;
				parent[j] = i;
				sons[i].push_back(j);
				level[j] = level[i] + 1;
				idx++;
				idxmin[j] = idx;
				q[idx] = j;
				niv++;
				stk[niv] = j;
				stkidx[niv] = -1;
			}
		}
	}

	fprintf(stderr, "idx=%d N=%d\n", idx, N);
	if (idx != N) {
		fprintf(stderr, "Bad test! The nodes do not form a tree!\n");
		exit(1);
	}
}

int color[NMAX];

void ProcessQueries() {
	int op, x, y, i, z, answer, qcnt = 0;

	freopen(FILEOUT, "w", stdout);

	if (DEBUG)
		freopen("log.txt", "w", stderr);
	
	memset(color, 0, sizeof(color));
	
	while (M--) {
		scanf("%d %d", &op, &x);
		if (op == 0) {
			color[x] = 1 - color[x];
		} else {
			scanf("%d", &y);
			answer = -1;

			if (DEBUG) {
				qcnt++;
				fprintf(stderr, "QUERY %d: x=%d (%d) y=%d (%d)\n", qcnt, x, level[x], y, level[y]);
			}
			
			if (color[x])
				answer = x;
			else {
				while (x != y) {
					if (DEBUG)
						fprintf(stderr, "  x=%d (%d)\n", x, level[x]);

					for (i = 0; i < sons[x].size(); i++) {
						z = sons[x][i];
						if (idxmin[z] <= idxmin[y] && idxmin[y] <= idxmax[z]) {
							x = z;
							break;
						}
					}
					
					if (color[x]) {
						answer = x;
						break;
					}
				}
				
				if (DEBUG)
					fprintf(stderr, "  final x=%d (%d %d)\n", x, level[x], color[x]);
			}
			
			printf("%d\n", answer);
		}
	}
}

int main() {
	int tstart = clock();

	ReadInput();
	DFS();
	ProcessQueries();

	fprintf(stderr, "Duration=%.3lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);
	return 0;
}
