#include <cstdio>
#include <vector>
#include <set>
#include <assert.h>

using namespace std;

#define FLIP 0
#define QUERY 1

#define ii pair<int, int>
#define NMAX 250000
#define MMAX 450001

const int lg = 250005;

bool fst[lg];
int inaltime[lg];
int tata[20][lg];

int aib[2 * lg];

vector<int> v[lg];
int ind, timp[lg][2];

bool isSet[lg];

void df(int nod, int adn) {
  fst[nod] = true;
  inaltime[nod] = adn;

  timp[nod][0] = ++ind;

  for (int i = 0; i < (int)v[nod].size(); i++) {
    if (!fst[v[nod][i]]) {
      tata[0][v[nod][i]] = nod;
      df(v[nod][i], adn + 1);
    }
  }

  timp[nod][1] = ++ind;
}

void aibUpdate(int poz, int val) {
  for (int i = poz; i <= ind; i += (i ^ (i - 1)) & i) {
    aib[i] += val;
  }
}

int aibQuery(int poz) {
  int rez = 0;

  for (int i = poz; i > 0; i -= (i ^ (i - 1)) & i) {
    rez += aib[i];
  }

  return rez;
}

void update(int nod) {
  int s;

  if (isSet[nod] == false) {
    isSet[nod] = true;

    s = 1;
  } else {
    isSet[nod] = false;

    s = -1;
  }

  aibUpdate(timp[nod][0], s);
  aibUpdate(timp[nod][1], -s);
}

int find(int nod, int k) {
  if (k == 0) {
    return nod;
  }

  for (int i = 18; i >= 0; i--) {
    if ((k & (1 << i)) > 0) {
      nod = tata[i][nod];
    }
  }

  return nod;
}

int query(int x, int y) {
  int suma, rsp = -1;

  if (x == 1) {
    suma = 0;
  } else {
    suma = aibQuery(timp[tata[0][x]][0]);
  }

  int li = 0, ls = inaltime[y] - inaltime[x];

  while (li <= ls) {
    int cur = (li + ls) / 2;

    int stramos = find(y, cur);

    if (aibQuery(timp[stramos][0]) - suma == 0) {
      ls = cur - 1;
    } else {
      li = cur + 1;
      rsp = stramos;
    }
  }

  return rsp;
}

int main() {
  freopen("confuzie.in", "rt", stdin);
  freopen("confuzie.out", "wt", stdout);

  int n, m, x, y;

  assert(scanf("%d%d", &n, &m) == 2);

  assert(1 <= n && n <= NMAX);
  assert(1 <= m && m <= MMAX);

  for (int i = 1; i < n; i++) {
    assert(scanf("%d%d", &x, &y) == 2);
    assert(1 <= x && x <= n);
    assert(1 <= y && y <= n);

    v[x].push_back(y);
    v[y].push_back(x);
  }

  df(1, 1);

  for (int i = 1; i <= 19; i++) {
    for (int j = 1; j <= n; j++) {
      tata[i][j] = tata[i - 1][tata[i - 1][j]];
    }
  }

  for (int i = 0; i < m; i++) {
    int tip, nod;

    assert(scanf("%d", &tip) == 1);
    assert(tip == FLIP || tip == QUERY);

    if (tip == FLIP) {
      assert(scanf("%d", &nod) == 1);
      assert(1 <= nod && nod <= n);

      update(nod);
    } else {
      assert(scanf("%d%d", &x, &y) == 2);

      assert(1 <= x && x <= n);
      assert(1 <= y && y <= n);

      assert(timp[x][0] <= timp[y][0] && timp[y][1] <= timp[x][1]);


      printf("%d\n", query(x, y));
    }
  }

  return 0;
}

