/* (C) 2013 Bogdan Cristian Tataroiu */

#include <stdio.h>
#include <string.h>
#include <assert.h>

#define MAXN 100
#define MAXM 1000
#define MAXC 1000000

int N, cnt[MAXC], lastSeen[MAXC], cntMult[MAXC];
int v[MAXM];

inline int min(int a, int b) {
    if (a < b) {
        return a;
    }
    return b;
}

int main() {
    assert(freopen("ausoara.in", "rt", stdin));
    assert(freopen("ausoara.out", "wt", stdout));

    memset(cnt, 0x3f, sizeof(cnt));
    memset(lastSeen, -1, sizeof(lastSeen));
    memset(cntMult, 0, sizeof(cntMult));

    int i, j;
    assert(scanf("%d", &N) == 1);
    assert(1 <= N && N <= MAXN);
    for (i = 0; i < N; i++) {
        int M;
        assert(scanf("%d", &M) == 1);
        assert(1 <= M && M <= MAXM);

        for (j = 0; j < M; j++) {
            assert(scanf("%d", v + j) == 1);
            assert(1 <= v[j] && v[j] <= MAXC);
            cntMult[v[j] - 1] += 1;
        }

        for (j = 0; j < M; j++) {
            if (lastSeen[v[j] - 1] < i - 1) {
                cnt[v[j] - 1] = 0;
            } else {
                cnt[v[j] - 1] = min(cnt[v[j] - 1], cntMult[v[j] - 1]);
                lastSeen[v[j] - 1] = i;
            }
        }

        for (j = 0; j < M; j++) {
            cntMult[v[j] - 1] -= 1;
        }
    }

    int CNT = 0;
    for (i = 0; i < MAXC; i++) {
        if (lastSeen[i] == N - 1) {
            CNT += cnt[i];
        }
    }
    printf("%d", CNT);
    for (i = 0; i < MAXC; i++) {
        for (; lastSeen[i] == N - 1 && cnt[i]; cnt[i]--) {
            printf(" %d", i + 1);
        }
    }
    printf("\n");

    return 0;
}
