/* (C) 2013 Bogdan Cristian Tataroiu */

#include <stdio.h>
#include <assert.h>

#define MAXN 1000000000000000LL
#define MAXX 100000
#define MAXK 1000000000000000LL
#define MOD 666013

int X;
long long N, K;

inline int modPow(int v, long long power) {
    long long step = 1LL;
    int rez = 1;
    for (; step <= power; step <<= 1) {
        if (power & step) {
            rez = (rez * (long long)v) % MOD;
        }
        v = (v * (long long)v) % MOD;
    }
    return rez;
}

int main() {
    assert(freopen("xnumere.in", "rt", stdin));
    assert(freopen("xnumere.out", "wt", stdout));

    assert(scanf("%lld %d %lld", &K, &X, &N) == 3);
    assert(1 <= N && N <= MAXN);
    assert(1 <= X && X <= K && X <= MAXX);
    assert(1 <= K && K <= MAXK);

    int i, SOL = 0, COMB = 1;

    for (i = 0; i <= X; i++) {
        if (i >= 1) {
            COMB = (COMB * (long long)(X - i + 1)) % MOD;
            COMB = (COMB * (long long)modPow(i, MOD - 2)) % MOD;
        }

        int V = (COMB * (long long)modPow(i, N)) % MOD;
        if ((X - i) % 2 == 0) {
            SOL += V;
            if (SOL >= MOD) {
                SOL -= MOD;
            }
        } else {
            SOL -= V;
            if (SOL < 0) {
                SOL += MOD;
            }
        }
    }

    long long p;
    for (p = K - X + 1; p <= K; p++) {
        SOL = (SOL * (p % MOD)) % MOD;
    }
    for (p = 1; p <= X; p++) {
        SOL = (SOL * (long long)modPow(p, MOD - 2)) % MOD;
    }

    printf("%d\n", SOL);

    return 0;
}
