// Mugurel Ionut Andreica
// O(X * log(N))

#include <stdio.h>
#include <string.h>

#define MOD 666013

int X, i, iinv;
long long K, N, answer, stirling, comb, kprod, xfact, term;

int ExtendedGCD(int A, int B, int &X, int &Y) {
    if (B == 0) {
        X = 1;
        Y = 0;
        return A;
    }
 
    int X0, Y0, D;
    D = ExtendedGCD(B, A % B, X0, Y0);
    X = Y0;
    Y = X0 - (A / B) * Y0;
    return D;
}

long long F[20][20];

void Brute() {
	int i, j;

	memset(F, 0, sizeof(F));

	F[0][0] = 1;
	
	for (i = 1; i <= N; i++)
		for (j = 1; j <= X; j++) {
			F[i][j] = 0;
			F[i][j] = (F[i][j] + F[i - 1][j] * j) % MOD;
			F[i][j] = (F[i][j] + F[i - 1][j - 1] * ((K - (j - 1)) % MOD)) % MOD;
		}

	fprintf(stderr, "brute: %lld\n", F[N][X]);
}

long long Power(long long P, long long Q) {
	long long answer;
	if (Q == 0)
		return 1;
	if (Q == 1)
		return (P % MOD);
	answer = Power(P, Q / 2);
	answer = (answer * answer) % MOD;
	if (Q % 2 == 1)
		answer = (answer * P) % MOD;
	return answer;
}

int Inv(int i) {
	int inv, garbage;
	ExtendedGCD(i, MOD, inv, garbage);
	inv %= MOD;
    while (inv < 0)
		inv += MOD;
	return inv;
}

int main() {
	freopen("xnumere.in", "r", stdin);
	scanf("%lld %d %lld", &K, &X, &N);
	//Brute();

	xfact = 1;
	for (i = 2; i <= X; i++)
		xfact = (xfact * i) % MOD;
	xfact = Inv(xfact);
	
	stirling = 0;
	comb = 1;

	for (i = 1; i <= X; i++) {
		comb = (comb * ((X - i + 1) % MOD)) % MOD;
		comb = (comb * Inv(i)) % MOD;
		term = (comb * Power(i, N)) % MOD;
		if ((X - i) % 2 == 0)
			stirling = (stirling + term) % MOD;
		else
			stirling = (stirling - term + MOD) % MOD;
	}
	
	answer = (stirling * xfact) % MOD;
	for (i = 0; i < X; i++)
		answer = (answer * ((K - i) % MOD)) % MOD;
	
	freopen("xnumere.out", "w", stdout);
	printf("%lld\n", answer);	
	return 0;
}
