/* (C) 2013 Bogdan Cristian Tataroiu */

#include <stdio.h>
#include <assert.h>

#define MAXN 1000000000000000LL
#define MAXX 100000
#define MAXK 1000000000000000LL
#define MOD 666013

int X;
long long N, K;

int comb[2][MAXX + 1];
int d[MAXX + 1];

inline int modPow(int v, long long power) {
    long long step = 1LL;
    int rez = 1;
    for (; step <= power; step <<= 1) {
        if (power & step) {
            rez = (rez * (long long)v) % MOD;
        }
        v = (v * (long long)v) % MOD;
    }
    return rez;
}

int main() {
    assert(freopen("xnumere.in", "rt", stdin));
    assert(freopen("xnumere.out", "wt", stdout));

    assert(scanf("%lld %d %lld", &K, &X, &N) == 3);
    assert(1 <= N && N <= MAXN);
    assert(1 <= X && X <= K && X <= MAXX);
    assert(1 <= K && K <= MAXK);

    int i, j;
    comb[0][0] = 1;
    for (i = 1; i <= X; i++) {
        comb[i & 1][0] = 1;
        for (j = 1; j <= i; j++) {
            comb[i & 1][j] = comb[(i - 1) & 1][j - 1] + comb[(i - 1) & 1][j];
            if (comb[i & 1][j] >= MOD) {
                comb[i & 1][j] -= MOD;
            }
        }

        d[i] = modPow(i, N);
        for (j = 1; j < i; j++) {
            d[i] -= (d[j] * (long long)comb[i & 1][j]) % MOD;
            if (d[i] < 0) {
                d[i] += MOD;
            }
        }
    }

    int SOL = d[X];
    for (i = X + 1; i <= K; i++) {
        SOL = (SOL * (long long)i) % MOD;
    }
    for (i = 1; i <= K - X; i++) {
        SOL = (SOL * (long long)modPow(i, MOD - 2)) % MOD;
    }

    printf("%d\n", SOL);

    return 0;
}
